Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.domain.solution.descriptor
Class SolutionDescriptor

    java.lang.Object
      org.optaplanner.core.impl.domain.solution.descriptor.SolutionDescriptor

    public class SolutionDescriptor

extends Object

Constructor Summary
`SolutionDescriptor(Class<? extends Solution> solutionClass)`

Method Summary
`void` | `addPlanningEntityDescriptor(PlanningEntityDescriptor entityDescriptor)`
`void` | `afterAnnotationsProcessed(DescriptorPolicy descriptorPolicy)`
`PlanningVariableListenerSupport` | `buildVariableListenerSupport()`
`int` | `countUninitializedVariables(Solution solution)`
`PlanningVariableDescriptor` | `findVariableDescriptor(Object entity, String variableName)`
`Collection<Object>` | `getAllFacts(Solution solution)`
`Collection<PlanningVariableDescriptor>` | `getChainedVariableDescriptors()`
`Map<String,PropertyAccessor>` | `getEntityCollectionPropertyAccessorMap()`
`int` | `getEntityCount(Solution solution)`
`PlanningEntityDescriptor` | `getEntityDescriptor(Class<?> entitySubclass)`
`Collection<PlanningEntityDescriptor>` | `getEntityDescriptors()`
`PlanningEntityDescriptor` | `getEntityDescriptorStrict(Class<?> planningEntityClass)`
`List<Object>` | `getEntityList(Solution solution)`
`List<Object>` | `getEntityListByPlanningEntityClass(Solution solution, Class<?> planningEntityClass)`
`Map<String,PropertyAccessor>` | `getEntityPropertyAccessorMap()`
`Collection<PlanningEntityDescriptor>` | `getGenuineEntityDescriptors()`
`Set<Class<?>>` | `getPlanningEntityClassSet()`
`long` | `getProblemScale(Solution solution)` Calculates an indication on how big this problem instance is.
`PropertyAccessor` | `getPropertyAccessor(String propertyName)`
`Class<? extends Solution>` | `getSolutionClass()`
`SolutionCloner` | `getSolutionCloner()`
`int` | `getValueCount(Solution solution)`
`boolean` | `hasEntityDescriptor(Class<?> entitySubclass)`
`boolean` | `hasEntityDescriptorStrict(Class<?> planningEntityClass)`
`boolean` | `isInitialized(ScoreDirector scoreDirector, Solution solution)`
`void` | `processAnnotations(DescriptorPolicy descriptorPolicy)`
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SolutionDescriptor

    public SolutionDescriptor(Class<? extends Solution> solutionClass)

Method Detail

### addPlanningEntityDescriptor

    public void addPlanningEntityDescriptor(PlanningEntityDescriptor entityDescriptor)

### processAnnotations

    public void processAnnotations(DescriptorPolicy descriptorPolicy)

### afterAnnotationsProcessed

    public void afterAnnotationsProcessed(DescriptorPolicy descriptorPolicy)

### getSolutionClass

    public Class<? extends Solution> getSolutionClass()

### getSolutionCloner

    public SolutionCloner getSolutionCloner()

### getEntityPropertyAccessorMap

    public Map<String,PropertyAccessor> getEntityPropertyAccessorMap()

### getEntityCollectionPropertyAccessorMap

    public Map<String,PropertyAccessor> getEntityCollectionPropertyAccessorMap()

### getPropertyAccessor

    public PropertyAccessor getPropertyAccessor(String propertyName)

### getPlanningEntityClassSet

    public Set<Class<?>> getPlanningEntityClassSet()

### getEntityDescriptors

    public Collection<PlanningEntityDescriptor> getEntityDescriptors()

### getGenuineEntityDescriptors

    public Collection<PlanningEntityDescriptor> getGenuineEntityDescriptors()

### hasEntityDescriptorStrict

    public boolean hasEntityDescriptorStrict(Class<?> planningEntityClass)

### getEntityDescriptorStrict

    public PlanningEntityDescriptor getEntityDescriptorStrict(Class<?> planningEntityClass)

### hasEntityDescriptor

    public boolean hasEntityDescriptor(Class<?> entitySubclass)

### getEntityDescriptor

    public PlanningEntityDescriptor getEntityDescriptor(Class<?> entitySubclass)

### getChainedVariableDescriptors

    public Collection<PlanningVariableDescriptor> getChainedVariableDescriptors()

### buildVariableListenerSupport

    public PlanningVariableListenerSupport buildVariableListenerSupport()

### findVariableDescriptor

    public PlanningVariableDescriptor findVariableDescriptor(Object entity,
                                                             String variableName)

### getAllFacts

    public Collection<Object> getAllFacts(Solution solution)

### getEntityCount

    public int getEntityCount(Solution solution)

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### getEntityList

    public List<Object> getEntityList(Solution solution)

### getEntityListByPlanningEntityClass

    public List<Object> getEntityListByPlanningEntityClass(Solution solution,
                                                           Class<?> planningEntityClass)

### getValueCount

    public int getValueCount(Solution solution)

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### getProblemScale

    public long getProblemScale(Solution solution)

  Calculates an indication on how big this problem instance is. This is intentionally very loosely defined for now.

  Parameters:
    `solution` - never null
  Returns:
    >= 0

### countUninitializedVariables

    public int countUninitializedVariables(Solution solution)

### isInitialized

    public boolean isInitialized(ScoreDirector scoreDirector,
                                 Solution solution)

  Parameters:
    `scoreDirector` - never null
    `solution` - never null
  Returns:
    true if all the movable planning entities are initialized

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.1.0.Beta1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2014 JBoss by Red Hat. All Rights Reserved.